declare type NonFunctionPropertyNames<T> = {
    [K in keyof T]: T[K] extends Function ? never : K;
}[keyof T];
declare type NonFunctionProperties<T> = Pick<T, NonFunctionPropertyNames<T>>;
export declare abstract class Initializable<T> {
    constructor(fields: NonFunctionProperties<T>);
}
export declare abstract class OptionallyInitializable<T> {
    constructor(fields?: NonFunctionProperties<T>);
}
export declare abstract class PartiallyInitializable<T> {
    constructor(fields: Partial<NonFunctionProperties<T>>);
}
export declare abstract class OptionallyPartiallyInitializable<T> {
    constructor(fields?: Partial<NonFunctionProperties<T>>);
}
export {};
